package com.hfkj.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class BsGasOrderSpreadExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public BsGasOrderSpreadExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andOrderNoIsNull() {
            addCriterion("order_no is null");
            return (Criteria) this;
        }

        public Criteria andOrderNoIsNotNull() {
            addCriterion("order_no is not null");
            return (Criteria) this;
        }

        public Criteria andOrderNoEqualTo(String value) {
            addCriterion("order_no =", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotEqualTo(String value) {
            addCriterion("order_no <>", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoGreaterThan(String value) {
            addCriterion("order_no >", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoGreaterThanOrEqualTo(String value) {
            addCriterion("order_no >=", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoLessThan(String value) {
            addCriterion("order_no <", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoLessThanOrEqualTo(String value) {
            addCriterion("order_no <=", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoLike(String value) {
            addCriterion("order_no like", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotLike(String value) {
            addCriterion("order_no not like", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoIn(List<String> values) {
            addCriterion("order_no in", values, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotIn(List<String> values) {
            addCriterion("order_no not in", values, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoBetween(String value1, String value2) {
            addCriterion("order_no between", value1, value2, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotBetween(String value1, String value2) {
            addCriterion("order_no not between", value1, value2, "orderNo");
            return (Criteria) this;
        }

        public Criteria andGainsRebateUserIdIsNull() {
            addCriterion("gains_rebate_user_id is null");
            return (Criteria) this;
        }

        public Criteria andGainsRebateUserIdIsNotNull() {
            addCriterion("gains_rebate_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andGainsRebateUserIdEqualTo(Long value) {
            addCriterion("gains_rebate_user_id =", value, "gainsRebateUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateUserIdNotEqualTo(Long value) {
            addCriterion("gains_rebate_user_id <>", value, "gainsRebateUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateUserIdGreaterThan(Long value) {
            addCriterion("gains_rebate_user_id >", value, "gainsRebateUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("gains_rebate_user_id >=", value, "gainsRebateUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateUserIdLessThan(Long value) {
            addCriterion("gains_rebate_user_id <", value, "gainsRebateUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateUserIdLessThanOrEqualTo(Long value) {
            addCriterion("gains_rebate_user_id <=", value, "gainsRebateUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateUserIdIn(List<Long> values) {
            addCriterion("gains_rebate_user_id in", values, "gainsRebateUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateUserIdNotIn(List<Long> values) {
            addCriterion("gains_rebate_user_id not in", values, "gainsRebateUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateUserIdBetween(Long value1, Long value2) {
            addCriterion("gains_rebate_user_id between", value1, value2, "gainsRebateUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateUserIdNotBetween(Long value1, Long value2) {
            addCriterion("gains_rebate_user_id not between", value1, value2, "gainsRebateUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateRateIsNull() {
            addCriterion("gains_rebate_rate is null");
            return (Criteria) this;
        }

        public Criteria andGainsRebateRateIsNotNull() {
            addCriterion("gains_rebate_rate is not null");
            return (Criteria) this;
        }

        public Criteria andGainsRebateRateEqualTo(BigDecimal value) {
            addCriterion("gains_rebate_rate =", value, "gainsRebateRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateRateNotEqualTo(BigDecimal value) {
            addCriterion("gains_rebate_rate <>", value, "gainsRebateRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateRateGreaterThan(BigDecimal value) {
            addCriterion("gains_rebate_rate >", value, "gainsRebateRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateRateGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("gains_rebate_rate >=", value, "gainsRebateRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateRateLessThan(BigDecimal value) {
            addCriterion("gains_rebate_rate <", value, "gainsRebateRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateRateLessThanOrEqualTo(BigDecimal value) {
            addCriterion("gains_rebate_rate <=", value, "gainsRebateRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateRateIn(List<BigDecimal> values) {
            addCriterion("gains_rebate_rate in", values, "gainsRebateRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateRateNotIn(List<BigDecimal> values) {
            addCriterion("gains_rebate_rate not in", values, "gainsRebateRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateRateBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("gains_rebate_rate between", value1, value2, "gainsRebateRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateRateNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("gains_rebate_rate not between", value1, value2, "gainsRebateRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateAmountIsNull() {
            addCriterion("gains_rebate_amount is null");
            return (Criteria) this;
        }

        public Criteria andGainsRebateAmountIsNotNull() {
            addCriterion("gains_rebate_amount is not null");
            return (Criteria) this;
        }

        public Criteria andGainsRebateAmountEqualTo(BigDecimal value) {
            addCriterion("gains_rebate_amount =", value, "gainsRebateAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateAmountNotEqualTo(BigDecimal value) {
            addCriterion("gains_rebate_amount <>", value, "gainsRebateAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateAmountGreaterThan(BigDecimal value) {
            addCriterion("gains_rebate_amount >", value, "gainsRebateAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("gains_rebate_amount >=", value, "gainsRebateAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateAmountLessThan(BigDecimal value) {
            addCriterion("gains_rebate_amount <", value, "gainsRebateAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("gains_rebate_amount <=", value, "gainsRebateAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateAmountIn(List<BigDecimal> values) {
            addCriterion("gains_rebate_amount in", values, "gainsRebateAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateAmountNotIn(List<BigDecimal> values) {
            addCriterion("gains_rebate_amount not in", values, "gainsRebateAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("gains_rebate_amount between", value1, value2, "gainsRebateAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("gains_rebate_amount not between", value1, value2, "gainsRebateAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneUserIdIsNull() {
            addCriterion("gains_rebate_one_user_id is null");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneUserIdIsNotNull() {
            addCriterion("gains_rebate_one_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneUserIdEqualTo(Long value) {
            addCriterion("gains_rebate_one_user_id =", value, "gainsRebateOneUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneUserIdNotEqualTo(Long value) {
            addCriterion("gains_rebate_one_user_id <>", value, "gainsRebateOneUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneUserIdGreaterThan(Long value) {
            addCriterion("gains_rebate_one_user_id >", value, "gainsRebateOneUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("gains_rebate_one_user_id >=", value, "gainsRebateOneUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneUserIdLessThan(Long value) {
            addCriterion("gains_rebate_one_user_id <", value, "gainsRebateOneUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneUserIdLessThanOrEqualTo(Long value) {
            addCriterion("gains_rebate_one_user_id <=", value, "gainsRebateOneUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneUserIdIn(List<Long> values) {
            addCriterion("gains_rebate_one_user_id in", values, "gainsRebateOneUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneUserIdNotIn(List<Long> values) {
            addCriterion("gains_rebate_one_user_id not in", values, "gainsRebateOneUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneUserIdBetween(Long value1, Long value2) {
            addCriterion("gains_rebate_one_user_id between", value1, value2, "gainsRebateOneUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneUserIdNotBetween(Long value1, Long value2) {
            addCriterion("gains_rebate_one_user_id not between", value1, value2, "gainsRebateOneUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneRateIsNull() {
            addCriterion("gains_rebate_one_rate is null");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneRateIsNotNull() {
            addCriterion("gains_rebate_one_rate is not null");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneRateEqualTo(BigDecimal value) {
            addCriterion("gains_rebate_one_rate =", value, "gainsRebateOneRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneRateNotEqualTo(BigDecimal value) {
            addCriterion("gains_rebate_one_rate <>", value, "gainsRebateOneRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneRateGreaterThan(BigDecimal value) {
            addCriterion("gains_rebate_one_rate >", value, "gainsRebateOneRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneRateGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("gains_rebate_one_rate >=", value, "gainsRebateOneRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneRateLessThan(BigDecimal value) {
            addCriterion("gains_rebate_one_rate <", value, "gainsRebateOneRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneRateLessThanOrEqualTo(BigDecimal value) {
            addCriterion("gains_rebate_one_rate <=", value, "gainsRebateOneRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneRateIn(List<BigDecimal> values) {
            addCriterion("gains_rebate_one_rate in", values, "gainsRebateOneRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneRateNotIn(List<BigDecimal> values) {
            addCriterion("gains_rebate_one_rate not in", values, "gainsRebateOneRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneRateBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("gains_rebate_one_rate between", value1, value2, "gainsRebateOneRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneRateNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("gains_rebate_one_rate not between", value1, value2, "gainsRebateOneRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneAmountIsNull() {
            addCriterion("gains_rebate_one_amount is null");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneAmountIsNotNull() {
            addCriterion("gains_rebate_one_amount is not null");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneAmountEqualTo(BigDecimal value) {
            addCriterion("gains_rebate_one_amount =", value, "gainsRebateOneAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneAmountNotEqualTo(BigDecimal value) {
            addCriterion("gains_rebate_one_amount <>", value, "gainsRebateOneAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneAmountGreaterThan(BigDecimal value) {
            addCriterion("gains_rebate_one_amount >", value, "gainsRebateOneAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("gains_rebate_one_amount >=", value, "gainsRebateOneAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneAmountLessThan(BigDecimal value) {
            addCriterion("gains_rebate_one_amount <", value, "gainsRebateOneAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("gains_rebate_one_amount <=", value, "gainsRebateOneAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneAmountIn(List<BigDecimal> values) {
            addCriterion("gains_rebate_one_amount in", values, "gainsRebateOneAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneAmountNotIn(List<BigDecimal> values) {
            addCriterion("gains_rebate_one_amount not in", values, "gainsRebateOneAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("gains_rebate_one_amount between", value1, value2, "gainsRebateOneAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateOneAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("gains_rebate_one_amount not between", value1, value2, "gainsRebateOneAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoUserIdIsNull() {
            addCriterion("gains_rebate_two_user_id is null");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoUserIdIsNotNull() {
            addCriterion("gains_rebate_two_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoUserIdEqualTo(Long value) {
            addCriterion("gains_rebate_two_user_id =", value, "gainsRebateTwoUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoUserIdNotEqualTo(Long value) {
            addCriterion("gains_rebate_two_user_id <>", value, "gainsRebateTwoUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoUserIdGreaterThan(Long value) {
            addCriterion("gains_rebate_two_user_id >", value, "gainsRebateTwoUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("gains_rebate_two_user_id >=", value, "gainsRebateTwoUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoUserIdLessThan(Long value) {
            addCriterion("gains_rebate_two_user_id <", value, "gainsRebateTwoUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoUserIdLessThanOrEqualTo(Long value) {
            addCriterion("gains_rebate_two_user_id <=", value, "gainsRebateTwoUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoUserIdIn(List<Long> values) {
            addCriterion("gains_rebate_two_user_id in", values, "gainsRebateTwoUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoUserIdNotIn(List<Long> values) {
            addCriterion("gains_rebate_two_user_id not in", values, "gainsRebateTwoUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoUserIdBetween(Long value1, Long value2) {
            addCriterion("gains_rebate_two_user_id between", value1, value2, "gainsRebateTwoUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoUserIdNotBetween(Long value1, Long value2) {
            addCriterion("gains_rebate_two_user_id not between", value1, value2, "gainsRebateTwoUserId");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoRateIsNull() {
            addCriterion("gains_rebate_two_rate is null");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoRateIsNotNull() {
            addCriterion("gains_rebate_two_rate is not null");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoRateEqualTo(BigDecimal value) {
            addCriterion("gains_rebate_two_rate =", value, "gainsRebateTwoRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoRateNotEqualTo(BigDecimal value) {
            addCriterion("gains_rebate_two_rate <>", value, "gainsRebateTwoRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoRateGreaterThan(BigDecimal value) {
            addCriterion("gains_rebate_two_rate >", value, "gainsRebateTwoRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoRateGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("gains_rebate_two_rate >=", value, "gainsRebateTwoRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoRateLessThan(BigDecimal value) {
            addCriterion("gains_rebate_two_rate <", value, "gainsRebateTwoRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoRateLessThanOrEqualTo(BigDecimal value) {
            addCriterion("gains_rebate_two_rate <=", value, "gainsRebateTwoRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoRateIn(List<BigDecimal> values) {
            addCriterion("gains_rebate_two_rate in", values, "gainsRebateTwoRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoRateNotIn(List<BigDecimal> values) {
            addCriterion("gains_rebate_two_rate not in", values, "gainsRebateTwoRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoRateBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("gains_rebate_two_rate between", value1, value2, "gainsRebateTwoRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoRateNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("gains_rebate_two_rate not between", value1, value2, "gainsRebateTwoRate");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoAmountIsNull() {
            addCriterion("gains_rebate_two_amount is null");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoAmountIsNotNull() {
            addCriterion("gains_rebate_two_amount is not null");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoAmountEqualTo(BigDecimal value) {
            addCriterion("gains_rebate_two_amount =", value, "gainsRebateTwoAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoAmountNotEqualTo(BigDecimal value) {
            addCriterion("gains_rebate_two_amount <>", value, "gainsRebateTwoAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoAmountGreaterThan(BigDecimal value) {
            addCriterion("gains_rebate_two_amount >", value, "gainsRebateTwoAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("gains_rebate_two_amount >=", value, "gainsRebateTwoAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoAmountLessThan(BigDecimal value) {
            addCriterion("gains_rebate_two_amount <", value, "gainsRebateTwoAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("gains_rebate_two_amount <=", value, "gainsRebateTwoAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoAmountIn(List<BigDecimal> values) {
            addCriterion("gains_rebate_two_amount in", values, "gainsRebateTwoAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoAmountNotIn(List<BigDecimal> values) {
            addCriterion("gains_rebate_two_amount not in", values, "gainsRebateTwoAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("gains_rebate_two_amount between", value1, value2, "gainsRebateTwoAmount");
            return (Criteria) this;
        }

        public Criteria andGainsRebateTwoAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("gains_rebate_two_amount not between", value1, value2, "gainsRebateTwoAmount");
            return (Criteria) this;
        }

        public Criteria andStatusIsNull() {
            addCriterion("`status` is null");
            return (Criteria) this;
        }

        public Criteria andStatusIsNotNull() {
            addCriterion("`status` is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEqualTo(Integer value) {
            addCriterion("`status` =", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotEqualTo(Integer value) {
            addCriterion("`status` <>", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThan(Integer value) {
            addCriterion("`status` >", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("`status` >=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThan(Integer value) {
            addCriterion("`status` <", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThanOrEqualTo(Integer value) {
            addCriterion("`status` <=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusIn(List<Integer> values) {
            addCriterion("`status` in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotIn(List<Integer> values) {
            addCriterion("`status` not in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusBetween(Integer value1, Integer value2) {
            addCriterion("`status` between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("`status` not between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andExt1IsNull() {
            addCriterion("ext_1 is null");
            return (Criteria) this;
        }

        public Criteria andExt1IsNotNull() {
            addCriterion("ext_1 is not null");
            return (Criteria) this;
        }

        public Criteria andExt1EqualTo(String value) {
            addCriterion("ext_1 =", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotEqualTo(String value) {
            addCriterion("ext_1 <>", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThan(String value) {
            addCriterion("ext_1 >", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThanOrEqualTo(String value) {
            addCriterion("ext_1 >=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThan(String value) {
            addCriterion("ext_1 <", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThanOrEqualTo(String value) {
            addCriterion("ext_1 <=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Like(String value) {
            addCriterion("ext_1 like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotLike(String value) {
            addCriterion("ext_1 not like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1In(List<String> values) {
            addCriterion("ext_1 in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotIn(List<String> values) {
            addCriterion("ext_1 not in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Between(String value1, String value2) {
            addCriterion("ext_1 between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotBetween(String value1, String value2) {
            addCriterion("ext_1 not between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt2IsNull() {
            addCriterion("ext_2 is null");
            return (Criteria) this;
        }

        public Criteria andExt2IsNotNull() {
            addCriterion("ext_2 is not null");
            return (Criteria) this;
        }

        public Criteria andExt2EqualTo(String value) {
            addCriterion("ext_2 =", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotEqualTo(String value) {
            addCriterion("ext_2 <>", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThan(String value) {
            addCriterion("ext_2 >", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThanOrEqualTo(String value) {
            addCriterion("ext_2 >=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThan(String value) {
            addCriterion("ext_2 <", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThanOrEqualTo(String value) {
            addCriterion("ext_2 <=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Like(String value) {
            addCriterion("ext_2 like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotLike(String value) {
            addCriterion("ext_2 not like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2In(List<String> values) {
            addCriterion("ext_2 in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotIn(List<String> values) {
            addCriterion("ext_2 not in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Between(String value1, String value2) {
            addCriterion("ext_2 between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotBetween(String value1, String value2) {
            addCriterion("ext_2 not between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt3IsNull() {
            addCriterion("ext_3 is null");
            return (Criteria) this;
        }

        public Criteria andExt3IsNotNull() {
            addCriterion("ext_3 is not null");
            return (Criteria) this;
        }

        public Criteria andExt3EqualTo(String value) {
            addCriterion("ext_3 =", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotEqualTo(String value) {
            addCriterion("ext_3 <>", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThan(String value) {
            addCriterion("ext_3 >", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThanOrEqualTo(String value) {
            addCriterion("ext_3 >=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThan(String value) {
            addCriterion("ext_3 <", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThanOrEqualTo(String value) {
            addCriterion("ext_3 <=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Like(String value) {
            addCriterion("ext_3 like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotLike(String value) {
            addCriterion("ext_3 not like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3In(List<String> values) {
            addCriterion("ext_3 in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotIn(List<String> values) {
            addCriterion("ext_3 not in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Between(String value1, String value2) {
            addCriterion("ext_3 between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotBetween(String value1, String value2) {
            addCriterion("ext_3 not between", value1, value2, "ext3");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}